package wpi.associations.arminer;

import java.util.*;
import java.io.*;
import weka.core.*;
import weka.associations.arminer.*;

public class Converter
{
	public static void WriteInstancesToDatabase(String databaseFileName, Instances dataset)
	{
		try{
		String ATTRIBUTE_VALUE_CONNECTOR = "=";
		
		DBWriter dbw = new DBWriter(databaseFileName);
		Enumeration attributes = dataset.enumerateAttributes();
		Enumeration values;
		Vector attributeNames = new Vector();
		Vector attributeIndices = new Vector();
		Attribute a;
		String s;
		int i;
		
		dbw.setDescription(dataset.relationName());
		
		while (attributes.hasMoreElements())
		{
			a = (Attribute)attributes.nextElement();
			
			values = a.enumerateValues();
			
			while (values.hasMoreElements())
			{
				s = a.name() + ATTRIBUTE_VALUE_CONNECTOR + (String)values.nextElement();
				
				attributeNames.addElement(s);
				attributeIndices.addElement(new Long((long)attributeNames.size()));
			}
		}
		
		for (i = 0; i < attributeNames.size(); i++)
		{
			System.out.println(attributeNames.elementAt(i));
		}
		
		dbw.setColumnNames(attributeNames);
		dbw.setAttributeIndexes(attributeIndices);
		
		Enumeration instances = dataset.enumerateInstances();
		
		ARMinerItemset is;
		Instance ins;
		int index;
		
		while (instances.hasMoreElements())
		{
			is = new ARMinerItemset();
			ins = (Instance)instances.nextElement();
			
			for (i = 0; i < dataset.numAttributes(); i++)
			{
				s = ins.attribute(i).name() + ATTRIBUTE_VALUE_CONNECTOR + ins.value(i);
				index = attributeNames.indexOf(s);
				
				if (index != -1)
				{
					is.addItem(index + 1);
				}
			}
			
			dbw.addRow(is);
		}
		
		dbw.close();
		}
		catch (Exception e)
		{
			System.out.println("Failure.");
		}
	}
}
